洛谷 P10726 [GESP202406 八级] 空间跳跃

题目背景

对应的选择、判断题:https://ti.luogu.com.cn/problemset/1156

题目描述

小杨在二维空间中有 \(n\) 个水平挡板,并且挡板之间彼此不重叠,其中第 \(i\) 个挡板处于水平高度 \(h_i\),左右端点分别位于 \(l_i\) 与 \(r_i\)。

小杨可以在挡板上左右移动,当小杨移动到右端点时,如果再向右移动会竖直掉落,从而落到下方第一个挡板上,移动到左端点时同理。小杨在挡板上每移动 \(1\) 个单位长度会耗费 \(1\) 个单位时间,掉落时每掉落 \(1\) 个单位高度也会耗费 \(1\) 个单位时间。

小杨想知道,从第 \(s\) 个挡板上的左端点出发到第 \(t\) 个挡板需要耗费的最少时间是多少?

注意:可能无法从第 \(s\) 个挡板到达到第 \(t\) 个挡板。

输入格式

第一行包含一个正整数 \(n\),代表挡板数量。

第二行包含两个正整数 \(s,t\),含义如题面所示。

之后 \(n\) 行,每行包含三个正整数 \(l_i,r_i,h_i\),代表第 \(i\) 个挡板的左右端点位置与高度。

输出格式

输出一个整数代表需要耗费的最少时间,如果无法到达则输出 \(-1\)。

输入输出样例 #1

输入 #1

3
3 1
5 6 3
3 5 6
1 4 100000

输出 #1

100001

说明/提示

样例解释

耗费时间最少的移动方案为,从第 \(3\) 个挡板左端点移动到右端点,耗费 \(3\) 个单位时间,然后向右移动掉落到第 \(2\) 个挡板上,耗费 \(100000-6=99994\) 个单位时间,之后再向右移动 \(1\) 个单位长度,耗费 \(1\) 个单位时间,最后向右移动掉落到第 \(1\) 个挡板上,耗费 \(3\) 个单位时间。共耗费 \(100001\) 个单位时间。

数据范围

子任务编号 数据点占比 \(n\) 特殊条件
\(1\) \(20\%\) \(\leq 1000\) \(l_i=1\)
\(2\) \(40\%\) \(\leq 1000\) \(l_i=i,r_i=i+1\)
\(3\) \(40\%\) \(\leq 1000\)

对于全部数据,保证有 \(1\leq n\leq 1000\),\(1\leq l_i\leq r_i\leq 10^5\),\(1\leq h_i\leq 10^5\)。

算法分析

这题有最短路的做法,但我是用DP做的,首先DP要有最优子结构、重叠子问题和无后效性三个要求,这一题都具备了,所以可以用DP,现在来考虑状态,因为每一个平台都有从右边下和从左边下,所以设\(dp_i,_1\)表示从平台\(s\)到平台\(i\)的最左边要多久,\(dp_i,_2\)表示从平台\(s\)到平台\(i\)的最右边要多久。状态设计出来了,先考虑转移,因为如果要下去,走左边和右边是没有区别的,所以就是状态转移方程就是

\[左侧\\ dp_j,_1 = min(dp_i,_1+a_i.l-a_j.l+a_i.h-a_j.h,dp_j,_1)\\ dp_j,_2 = min(dp_i,_1+a_j.r-a_i.l+a_i.h-a_j.h,dp_j,_2)\\ 右侧\\ dp_j,_1 = min(dp_i,_2+a_i.r-a_j.l+a_i.h-a_j.h,dp_j,_1)\\ dp_j,_2 = min(dp_i,_2+a_j.r-a_i.r+a_i.h-a_j.h,dp_j,_2) \]

当遍历到t的时候要求最小值。

坑点

  1. 由于是要求最小值,所以要初始化成极大值。
  2. DP初始化是下标为$\ s\ $的,有左侧和右侧要初始化。
  3. DP是从\(\ s\) 到 $t\ $,其他的不必理会。
  4. 题目中没有说$\ h \ $有按降序输入,所以要排序。
  5. 排序后\(\ s\) 和 $t\ $都改变了顺序,所以要重新算。
  6. 有无解的情况,要判断。
  7. 不开\(long\ long\)见祖宗。

AC代码

#include<bits/stdc++.h>
#define int long long
using namespace std;
struct node{
	int l,r,h,id;
};
int n,s,t,x,y;
int mn = 1e12;
int dp[1005][5];
node a[1005];
bool cmp(node a,node b){
	if(a.h!=b.h){//排序规则
        return a.h>b.h;
    }else{
        return a.l<b.l;
    }
}
signed main(){	
    cin>>n>>s>>t;
    for(int i = 1; i<=n; i++){
    	cin>>a[i].l>>a[i].r>>a[i].h;
    	a[i].id = i;//编号
    	dp[i][1] = 1e12;//极大值
        dp[i][2] = 1e12;
    }
    sort(a+1,a+n+1,cmp);//排序
    for(int i = 1; i<=n; i++){
    	if(a[i].id==s){//重新算
            x = i;
        }if(a[i].id==t){
            y = i;
        }
    }
    dp[x][1] = 0;//初始化
    dp[x][2] = a[x].r-a[x].l;
    for(int i = x; i<=y; i++){//x到y
    	for(int j = i+1; j<=y; j++){
    		if(a[i].l>=a[j].l && a[i].l<=a[j].r && a[i].h>a[j].h){//满足条件
    			if(j==y){
                    mn = min(dp[i][1]+a[i].h-a[j].h,mn);//取最小值
                }
    			dp[j][1] = min(dp[i][1]+a[i].l-a[j].l+a[i].h-a[j].h,dp[j][1]);//转移
    			dp[j][2] = min(dp[i][1]+a[j].r-a[i].l+a[i].h-a[j].h,dp[j][2]);
    			break;//退出
    		}
    	}
    	for(int j = i+1; j<=y; j++){
    		if(a[i].r>=a[j].l && a[i].r<=a[j].r && a[i].h>a[j].h){//满足条件
    			if(j==y){
                    mn = min(dp[i][2]+a[i].h-a[j].h,mn);//取最小值
                }
    			dp[j][1] = min(dp[i][2]+a[i].r-a[j].l+a[i].h-a[j].h,dp[j][1]);//转移
    			dp[j][2] = min(dp[i][2]+a[j].r-a[i].r+a[i].h-a[j].h,dp[j][2]);
    			break;//退出
    		}
    	}
    }
    if(mn==1e12){
        cout<<-1;//无解
    }else{
        cout<<mn;
    }
    return 0;
}

总结

这题算是比较难的DP题了,状态和转移都很好想,但坑点较多,代码复杂难写,要调很久,算很难的绿题了。

posted @ 2026-08-24 20:25  xmgene  阅读(25)  评论(0)    收藏  举报